################################################################################
########################### Censored $t$ Mixed Models ############################
################################################################################

## Nonlinear case ##

## EM Algorithm ##

rm(list=ls(all=TRUE))

setwd("")

library(mvtnorm)
library(mnormt)
library(lmec)
library(tmvtnorm)

source("utils_EM_T_NL.R")

## Read the data

data1 <- read.csv("SETPOINTdata.csv")
all(!is.na(data1))
all(!is.nan(data1))
subjects = unique(data1$patid)
data1$subj = match(data1$patid,subjects)
m = length(subjects)
cluster = match(data1$patid,subjects);

y=log10(data1$vl)
cc=data1$cens
x=data1$day
days=unique(data1$day)
order(days)

nj<-matrix(0,m,1)
for (j in 1:m) {
nj[j]=sum(cluster==j)
}

m<-dim(nj)[1]


## Nonlinear functions ##

nlf<-function(t,beta1,u){
resp<-(exp(beta1[1]+u[1]))+(exp(beta1[2])/(1 + exp((t - exp(beta1[3]))/exp(beta1[4]))))+(((beta1[5]+u[2]))*(t - 50))
return(-resp) ## left censored
}

funcH<-function(t,u,beta1){

  ni<-length(t)
  resp<-matrix(0,ni,2)
  resp[,1]<- rep(exp(beta1[1]+u[1]),ni)
  resp[,2]<- (t - 50)

  return(-resp) ## left censored
}

funcW<-function(t,u,beta1){

  ni<-length(t)
  resp<-matrix(0,ni,length(beta1))
  resp[,1]<- rep(exp(beta1[1]+u[1]),ni)
  resp[,2]<- (exp(beta1[2])/(1 + exp((t - exp(beta1[3]))/exp(beta1[4]))))
  resp[,3]<- (exp(beta1[2]+exp(-beta1[4])*(t-exp(beta1[3]))-beta1[4]+beta1[3]))/((1 + exp((t - exp(beta1[3]))/exp(beta1[4])))^2)
  resp[,4]<- ((t-exp(beta1[3]))*exp(beta1[2]+exp(-beta1[4])*(t-exp(beta1[3]))-beta1[4]))/((1 + exp((t - exp(beta1[3]))/exp(beta1[4])))^2)
  resp[,5]<- (t - 50)

  return(-resp) ## left censored
}

nu<-10

aT<- EMT_NL(cc,-y,x,nj,nu) ## Fit T
EM_NCens<-aT

aN<- EMN_NL(cc,-y,x,nj) ## Fit Normal 
								
